Solid union errors - Unable to union two solids

Hi, I am unionizing each beam with its intersecting elements. Some were successful but some failed. I captured the errors as follows. Anyone knows where are the problems and how to fix it? Thanks!

 "System.ApplicationException: Unable union two Solids : BODY_VERTEX_CRUMBLE -- coincident face_face_ints with different body vertices
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"
"System.ApplicationException: Unable union two Solids : INCONS_VERT_ATT -- inconsistent information in vertex and coedge attributes
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"
"System.ApplicationException: Unable union two Solids : OUTSIDE_RANGE -- new ef_int outside edge
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"
"System.ApplicationException: Unable union two Solids : FACE_BOUNDARY -- wire being deleted crosses face boundary
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"
"System.ApplicationException: Unable union two Solids : EDGECOIN_PROBLEM -- system inconsistency processing edge coincidence
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"
"System.ApplicationException: Unable union two Solids : INCONS_VERT_ATT -- inconsistent information in vertex and coedge attributes
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"
"System.ApplicationException: Unable union two Solids : INCONS_REL -- inconsistent edge-face relationships
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"
"System.ApplicationException: Unable union two Solids : EDGECOIN_PROBLEM -- system inconsistency processing edge coincidence
   at Autodesk.LibG.Solid.csg_union(Solid other)
   at Autodesk.LibG.SolidHost.Union(ISolidEntity geometry)
   at Autodesk.DesignScript.Geometry.Solid.Union(Solid solid)"


The group in pink gets the intersected elements with each beam. I think it has no problems. The python script node is like this, which uses the try-except to capture the errors:

Here are the dynamo and model flies:
dynamo.dyn (38.3 KB)

It seems when the beam is fully surrounded it would fail. Below the first picture was successful but the second picture failed.
image
image

It seems some of the errors are due to the union sequence. I inserted the beam as the first item with its intersected elements and most of the errors are gone. But there are still two errors - INCONS_FACE -- inconsistent face-body relationships and FACE_BOUNDARY -- wire being deleted crosses face boundary. To be more clear, I think it is better to open another topic. The new topic is here Solid union errors - INCONS_FACE -- inconsistent face-body relationships and FACE_BOUNDARY -- wire being deleted crosses face boundary Thanks.